#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var board_1 = require("./board");
var schematic_1 = require("./schematic");
if (process.argv.length < 3) {
    console.error("Usage: " + process.argv[1] + " <input.json> [output.kicad_pcb]");
    process.exit(1);
}
if (process.argv[2] === '-v') {
    // tslint:disable-next-line
    console.log("Version " + require('../package.json').version);
    process.exit(0);
}
var input = JSON.parse(fs.readFileSync(process.argv[2], 'utf-8'));
var output = input.docType === '5' ? schematic_1.convertSchematic(input) : board_1.convertBoard(input);
var outputFile = process.argv[3];
if (outputFile && outputFile !== '-') {
    fs.writeFileSync(outputFile, output);
}
else {
    process.stdout.write(output);
}
//# sourceMappingURL=main.js.map